# Generated by Django 4.2 on 2023-04-17 11:47

from datetime import date, datetime, timezone

import django.db.models.deletion
from django.db import migrations, models

import seawatch_registration.models

# This isn't great, but we don't have the data.
fallback_created = datetime(1900, 1, 1, 0, 0, tzinfo=timezone.utc)


def up(apps, schema_editor):
    Volunteer = apps.get_model("volunteers", "Volunteer")
    # Generally, that field should never be None, but in exploratory testing it was after migrating
    # up and down :S
    for volunteer in Volunteer.objects.exclude(cv="").exclude(cv=None):
        volunteer.document_set.create(
            type="cv", file=volunteer.cv, metadata={}, created=fallback_created
        )

    RankRelatedDocuments = apps.get_model("volunteers", "RankRelatedDocuments")
    for rrd in RankRelatedDocuments.objects.select_related("volunteer"):
        volunteer = rrd.volunteer
        volunteer.document_set.create(
            type="stcw:basic_safety",
            file=rrd.basic_safety.file,
            metadata={"valid_until": rrd.basic_safety.expiry_date.isoformat()},
            created=fallback_created,
        )
        volunteer.document_set.create(
            type="medical_fitness",
            file=rrd.medical_fitness.file,
            metadata={"valid_until": rrd.medical_fitness.expiry_date.isoformat()},
            created=fallback_created,
        )
        if rrd.watchkeeping_license:
            volunteer.document_set.create(
                type="stcw:watchkeeping",
                file=rrd.watchkeeping_license.file,
                metadata={
                    "valid_until": rrd.watchkeeping_license.expiry_date.isoformat()
                },
                created=fallback_created,
            )


def down(apps, schema_editor):
    Volunteer = apps.get_model("volunteers", "Volunteer")
    Document = apps.get_model("volunteers", "Document")
    RankRelatedDocuments = apps.get_model("volunteers", "RankRelatedDocuments")
    DocumentWithExpiry = apps.get_model("volunteers", "DocumentWithExpiry")

    if Document.objects.exclude(
        type__in=["medical_fitness", "cv", "stcw:basic_safety", "stcw:watchkeeping"]
    ).exists():
        raise AssertionError("Unknown Document types in database, cannot downgrade")

    for volunteer in Volunteer.objects.exclude(document=None):
        if cv := volunteer.document_set.get(type="cv"):
            volunteer.cv = cv.file
            volunteer.save()
        match (
            list(volunteer.document_set.filter(type="medical_fitness")),
            list(volunteer.document_set.filter(type="stcw:basic_safety")),
        ):
            case None, None:
                pass
            case [[Document() as medical_fitness], [Document() as basic_safety]]:
                (watchkeeping,) = volunteer.document_set.filter(
                    type="stcw:watchkeeping"
                )
                RankRelatedDocuments.objects.create(
                    volunteer=volunteer,
                    medical_fitness=DocumentWithExpiry.objects.create(
                        file=medical_fitness.file,
                        expiry_date=date.fromisoformat(
                            medical_fitness.metadata["valid_until"]
                        ),
                    ),
                    basic_safety=DocumentWithExpiry.objects.create(
                        file=basic_safety.file,
                        expiry_date=date.fromisoformat(
                            basic_safety.metadata["valid_until"]
                        ),
                    ),
                    watchkeeping_license=(
                        DocumentWithExpiry.objects.create(
                            file=watchkeeping.file,
                            expiry_date=date.fromisoformat(
                                watchkeeping.metadata["valid_until"]
                            ),
                        )
                        if watchkeeping
                        else None
                    ),
                )
            case _a, _b:
                raise AssertionError(
                    "Volunteers must have either exactly one basic safety and medical fitness "
                    f"or neither, which doesn't hold true for volunteer #{volunteer.id}"
                )


class Migration(migrations.Migration):
    dependencies = [
        ("volunteers", "0036_application_removal_6_detach_application_from_volunteer"),
    ]

    operations = [
        migrations.CreateModel(
            name="Document",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "type",
                    seawatch_registration.models.ShortTextField(
                        choices=[
                            ("stcw:basic_safety", "STCW Basic Safety"),
                            ("stcw:watchkeeping", "STCW Watchkeeping"),
                            ("stcw:other", "STCW"),
                            ("medical_fitness", "Medical Fitness"),
                            ("cv", "CV"),
                        ]
                    ),
                ),
                ("file", models.FileField(upload_to="")),
                ("metadata", models.JSONField()),
                (
                    "volunteer",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="volunteers.volunteer",
                    ),
                ),
                ("created", models.DateTimeField()),
            ],
        ),
        migrations.RunPython(up, down),
        migrations.RemoveField(
            model_name="rankrelateddocuments",
            name="basic_safety",
        ),
        migrations.RemoveField(
            model_name="rankrelateddocuments",
            name="medical_fitness",
        ),
        migrations.RemoveField(
            model_name="rankrelateddocuments",
            name="volunteer",
        ),
        migrations.RemoveField(
            model_name="rankrelateddocuments",
            name="watchkeeping_license",
        ),
        migrations.DeleteModel(
            name="DocumentWithExpiry",
        ),
        migrations.DeleteModel(
            name="RankRelatedDocuments",
        ),
        migrations.RemoveField(
            model_name="volunteer",
            name="cv",
        ),
    ]
